#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Logo_SFR.ico
#AutoIt3Wrapper_UseUpx=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author:         Cetipabo

 Script Function:
	Affichage infos ONT Box SFR NB6VAC

#ce ----------------------------------------------------------------------------
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ColorConstants.au3>
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("SFR BOX ONT INFOS", 301, 170, 742, 292)
$Ranging = GUICtrlCreateLabel("Ranging : ", 16, 16, 53, 17)
$Receive = GUICtrlCreateLabel("Receive : ", 16, 40, 83, 17)
$Transmit = GUICtrlCreateLabel("Transmit : ", 16, 64, 83, 17)
$Bias = GUICtrlCreateLabel("Bias : ", 16, 88, 33, 17)
$Temp = GUICtrlCreateLabel("Temp : ", 16, 112, 40, 17)
$Vcc = GUICtrlCreateLabel("Vcc : ", 16, 136, 32, 17)
$Ranging_value = GUICtrlCreateLabel("", 80, 16, 100, 17)
$Receive_value = GUICtrlCreateLabel("", 80, 40, 100, 17)
$Transmit_value = GUICtrlCreateLabel("", 80, 64, 100, 17)
$Bias_value = GUICtrlCreateLabel("", 80, 88, 100, 17)
$Temp_value = GUICtrlCreateLabel("", 80, 112, 100, 17)
$Vcc_value = GUICtrlCreateLabel("", 80, 136, 100, 17)
#EndRegion ### END Koda GUI section ###

Global $ipbox

; On récupère l'adresse ip de la BOX en interrogeant son DNS avec le nom d'hote "box"
Local $aArray = _IPGateway()
If @error = 0 Then
    $ipbox = $aArray[0]
EndIf
;msgbox(0,"", $ipbox)

$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")

; On exécute la fonction qui va aller chercher les valeurs et les afficher dans la GUI
GetData()
AdlibRegister("GetData", 30000) ;On relance la fonction GetData toutes les 30 sec

;Fermeture de la GUI lorsqu'on clique sur la croix
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

	EndSwitch
WEnd


Func GetData()

; On vérifie que la box répond bien au ping avant d'acceder à son API
$ping = ping($ipbox)
if $ping = 0 then
	MsgBox(0,'Erreur de connexion',"La box n'est pas joignable sur l'IP : " & $ipbox)
	exit
Else
	$oHTTP.Open("GET", "http://" & $ipbox & "/api/1.0/?method=ont.getInfo", False)
	$oHTTP.Send()
	$oReceived = $oHTTP.ResponseText
EndIf

; On capture les valeurs du XML dans un array
$sranging = StringRegExp($oReceived,'<info name="ranging" value="(.*?)"', 3)
$srxdB = StringRegExp($oReceived,'<info name="receive" value="(.*?)"', 3)
$stxdB = StringRegExp($oReceived,'<info name="transmit" value="(.*?)"', 3)
$sbias = StringRegExp($oReceived,'<info name="bias" value="(.*?)"', 3)
$stemp = StringRegExp($oReceived,'<info name="temp" value="(.*?)"', 3)
$svcc = StringRegExp($oReceived,'<info name="vcc" value="(.*?)"', 3)

;on transforme la varibale array en variable string, pour simplifier
$sranging = $sranging[0]
$srxdB = $srxdB[0]
$stxdB = $stxdB[0]
$sbias = $sbias[0]
$stemp = $stemp[0]
$svcc = $svcc[0]

;Affichage des valeurs dans la GUI
GUICtrlSetData($Ranging_value, $sranging)
GUICtrlSetData($Receive_value, $srxdB & " dBm")
GUICtrlSetData($Transmit_value, $stxdB & " dBm")
GUICtrlSetData($Bias_value, $sbias & " mA")
GUICtrlSetData($Temp_value, $stemp & " °C")
GUICtrlSetData($Vcc_value, $svcc & " V")

;On met le texte en couleur (Vert/Rouge), en fonction de ce qui est annoncé ici : https://assistance.sfr.fr/internet-et-box/box-plus-de-sfr/verifier-fonctionnement-boitier-ont.html
if ($sranging="O5" OR $sranging="IS") Then
	GUICtrlSetColor($Ranging_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Ranging_value, $COLOR_RED)
EndIf

if ($srxdB<=-8 AND $srxdB>=-27) Then
	GUICtrlSetColor($Receive_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Receive_value, $COLOR_RED)
EndIf

if ($stxdB>=0.5 AND $stxdB<=5) Then
	GUICtrlSetColor($Transmit_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Transmit_value, $COLOR_RED)
EndIf

if ($sbias>=0 AND $sbias<=150) Then
	GUICtrlSetColor($Bias_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Bias_value, $COLOR_RED)
EndIf

if ($stemp>=-40 AND $stemp<=100) Then
	GUICtrlSetColor($Temp_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Temp_value, $COLOR_RED)
EndIf

if ($svcc>=3.05 AND $svcc<=3.55) Then
	GUICtrlSetColor($Vcc_value, $COLOR_GREEN)
Else
	GUICtrlSetColor($Vcc_value, $COLOR_RED)
EndIf

;on affiche la GUI
GUISetState(@SW_SHOW)

EndFunc		;GetData

Func _IPGateway()
    Local $oWMIService = ObjGet('winmgmts:{impersonationLevel = impersonate}!\\' & '.' & '\root\cimv2')
    Local $oColItems = $oWMIService.ExecQuery('Select * From Win32_NetworkAdapterConfiguration Where IPEnabled = True', 'WQL', 0x30), $aReturn[1] = [0]
    If IsObj($oColItems) Then
        For $oObjectItem In $oColItems
            If $oObjectItem.IPAddress(0) == @IPAddress1 Then
                $aReturn[0] = $oObjectItem.DefaultIPGateway(0)
            EndIf
        Next
    EndIf
    Return SetError($aReturn[0] = 0, 0, $aReturn)
EndFunc   ;==>_IPDetails